#ifndef classAngle
#define classAngle

class Angle;

#include "Constants.h"
#include <iostream>

//! Angle.
class Angle {

public:
	double mValue;

	Angle(): mValue(0) {}
	Angle(double value): mValue(value) {}

	void SetRad(double value) {
		mValue = value;
	}
	double GetRad() const {
		return mValue;
	}

	void SetDeg(double value) {
		mValue = value / 180 * PI;
	}
	double GetDeg() const {
		return mValue / PI * 180;
	}

	void SetGrad(double value) {
		mValue = value / 200 * PI;
	}
	double GetGrad() const {
		return mValue / PI * 200;
	}

	Angle Normalize(double base = 0) const;
	Angle Normalize(Angle base) const {
		return Normalize(base.mValue);
	}

	Angle operator - () const {
		return Angle(-mValue);
	}
	Angle operator + (const Angle &p) const {
		return Angle(mValue + p.mValue);
	}
	Angle operator - (const Angle &p) const {
		return Angle(mValue - p.mValue);
	}
	Angle operator * (double a) const {
		return Angle(mValue * a);
	}
	Angle operator / (double a) const {
		return Angle(mValue / a);
	}
	Angle operator * (const Angle &p) const {
		return mValue * p.mValue;
	}

	void operator += (const Angle &p) {
		mValue += p.mValue;
	}
	void operator -= (const Angle &p) {
		mValue -= p.mValue;
	}
	void operator *= (double a) {
		mValue *= a;
	}
	void operator /= (double a) {
		mValue /= a;
	}

	friend std::ostream &operator<<(std::ostream &stream, const Angle &p);
};

#endif
