#include "AngleDisplay.h"
#include <cmath>
#define THISCLASS AngleDisplay

std::ostream &operator<<(std::ostream &stream, const AngleDisplay &p) {
	if (p.mFormat == AngleDisplay::sFormatDeg) {
		stream << p.mAngle.GetDeg();
	} else if (p.mFormat == AngleDisplay::sFormatDegMinSec) {
		int commares = 100;
		int angleu = (int)floor(p.mAngle.GetDeg() * 3600 * commares + 0.5);
		int angles = angleu / commares;
		int anglem = angles / 60;
		int angled = anglem / 60;
		angleu = std::abs(angleu - angles * commares);
		angles = std::abs(angles - anglem * 60);
		anglem = std::abs(anglem - angled * 60);

		stream << angled << "° " << anglem << "' " << angles << ".";
		char oldfill = stream.fill('0');
		int oldwidth = stream.width(2);
		stream << angleu << "''";;
		stream.fill(oldfill);
		stream.width(oldwidth);
	} else if (p.mFormat == AngleDisplay::sFormatGrad) {
		stream << p.mAngle.GetGrad();
	} else {
		stream << p.mAngle.GetRad();
	}

	return stream;
}
