#ifndef classAngleDisplay
#define classAngleDisplay

class AngleDisplay;

#include "Angle.h"
#include <iostream>

//! AngleDisplay.
class AngleDisplay {

public:
	enum eFormat {
	    sFormatRad,
	    sFormatDeg,
	    sFormatDegMinSec,
	    sFormatGrad,
	    sFormatDefault = sFormatRad
	};

	eFormat mFormat;
	Angle mAngle;

	AngleDisplay(eFormat format = sFormatDefault): mFormat(format), mAngle() {}
	AngleDisplay(Angle angle, eFormat format = sFormatDefault): mFormat(format), mAngle(angle) {}
	AngleDisplay(double value, eFormat format = sFormatDefault): mFormat(format), mAngle(value) {}

	friend std::ostream &operator<<(std::ostream &stream, const AngleDisplay &p);
};

#endif
