#ifndef classDistance
#define classDistance

class Distance;

#include "Constants.h"
#include <iostream>

//! Distance (m).
class Distance {

public:
	double mValue;

	Distance(): mValue(0) {}
	Distance(double value): mValue(value) {}

	void Set(double value) {
		mValue = value;
	}
	double Get() const {
		return mValue;
	}

	Distance operator - () const {
		return Distance(-mValue);
	}
	Distance operator + (const Distance &p) const {
		return Distance(mValue + p.mValue);
	}
	Distance operator - (const Distance &p) const {
		return Distance(mValue - p.mValue);
	}
	Distance operator * (double a) const {
		return Distance(mValue * a);
	}
	Distance operator / (double a) const {
		return Distance(mValue / a);
	}
	Distance operator * (const Distance &p) const {
		return mValue * p.mValue;
	}

	void operator += (const Distance &p) {
		mValue += p.mValue;
	}
	void operator -= (const Distance &p) {
		mValue -= p.mValue;
	}
	void operator *= (double a) {
		mValue *= a;
	}
	void operator /= (double a) {
		mValue /= a;
	}

	friend std::ostream &operator<<(std::ostream &stream, const Distance &p);
};

#endif
