#ifndef classDistanceDisplay
#define classDistanceDisplay

class DistanceDisplay;

#include "Distance.h"
#include <iostream>

//! DistanceDisplay.
class DistanceDisplay {

public:
	enum eFormat {
	    sFormatPlain,
	    sFormatMeter,
	    sFormatKilometer,
	    sFormatDefault = sFormatPlain
	};

	eFormat mFormat;
	Distance mDistance;

	DistanceDisplay(eFormat format = sFormatDefault): mFormat(format), mDistance() {}
	DistanceDisplay(Distance dist, eFormat format = sFormatDefault): mFormat(format), mDistance(dist) {}
	DistanceDisplay(double value, eFormat format = sFormatDefault): mFormat(format), mDistance(value) {}

	friend std::ostream &operator<<(std::ostream &stream, const DistanceDisplay &p);
};

#endif
