#ifndef classDistanceParser
#define classDistanceParser

class DistanceParser;

#include <string>
#include "Distance.h"

/*!
	Parses a distance.

	The following strings are considered as equivalent:
		20.5 km
		20.5km
		20500
		20500m
		20500 m
		2050000 cm
		20km 500m
*/
class DistanceParser {

private:
	static const int mNumberMax = 32;
	char mNumber[mNumberMax + 1];
	int mNumberIndex;
	static const int mKeywordMax = 32;
	char mKeyword[mKeywordMax + 1];
	int mKeywordIndex;
	int mState;
	int mSign;
	double mDistance;

	bool AddDistance();

public:
	//! Constructor.
	DistanceParser();
	//! Constructor.
	DistanceParser(const std::string &str);

	//! Parses a string and adds it to the angle.
	bool ParseString(const std::string &text);
	//! Returns the distance.
	Distance GetValue();
};

#endif
