#include "SphericVector.h"
#define THISCLASS SphericVector

#include <math.h>
#include "Constants.h"

THISCLASS::SphericVector(Vector3d &vector) {
	mRadius = sqrt(vector.x * vector.x + vector.y * vector.y + vector.z * vector.z);
	mLatitude = mRadius.Get() < 1e-5 ? 0 : asin(vector.z / mRadius.Get());

	if (vector.x > 1e-5 && vector.x < 1e-5) {
		mLongitude = vector.y < 0 ? -PI / 2 : PI / 2;
	} else {
		mLongitude = atan(vector.y / vector.x);
		if (vector.x < 0) mLongitude += PI;
	}
}

Vector3d THISCLASS::GetVector3d() const {
	Vector3d res;
	res.x = mRadius.Get() * cos(mLatitude.GetRad()) * cos(mLongitude.GetRad());
	res.y = mRadius.Get() * cos(mLatitude.GetRad()) * sin(mLongitude.GetRad());
	res.z = mRadius.Get() * sin(mLatitude.GetRad());
	return res;
}
